/*-
 * Copyright (c) 2008, Alexandre P. Francisco <aplf@ist.utl.pt>
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef PQUEUE_H
#define PQUEUE_H

#include "gcfnd.h"

#define KEY_T struct adj_node

typedef struct _pqueue pqueue;

pqueue	*pqueue_new(size_t, KEY_T*, int (*)(KEY_T *, KEY_T *));
void	pqueue_free(pqueue *);

void	pqueue_push(pqueue *, size_t);
void	pqueue_remove(pqueue *, size_t);
void	pqueue_update(pqueue *, size_t);

int	pqueue_has(pqueue *, size_t);

void	pqueue_pop(pqueue *);
size_t	pqueue_top(pqueue *);
int	pqueue_empty(pqueue *);

#endif /* PQUEUE_H */
